
// El5001Dlg.h : Y
//

#pragma once
#include <stdint.h>
#include "EcatDeviceAPI.h"
#include "EcatErrno.h"
#include "afxwin.h"
#define timeout 3
#define DEV_TIMER_CYCLE_TIME 30 //ms

typedef struct EL5001_t //EL5001 TxPDO struct
{
	uint64_t Status		:8;
	uint64_t Value		:32;
}EL5001_st;


// CEl5001Dlg ܤ
class CEl5001Dlg : public CDialog
{
// غc
public:
	CEl5001Dlg(CWnd* pParent = NULL);	// зǫغc禡

// ܤ
	enum { IDD = IDD_EL5001_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV 䴩


// {X@
protected:
	HICON m_hIcon;

	// ͪT禡
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	uint16_t DeviceNo;
	clock_t startTime;
	bool isOP;

	EL5001_st EL5001;//Data type of the module 

	uint16_t EL5001_SlaveNo; // The position of the module in the ethercat network

	CEdit WgLblSlavesResp;	//The number of modules in a network
	CEdit WgLblAlStates;	//Al state of ethercat master
	CEdit WgLblWc;			//working counter of ethercat master
	CEdit WgLblLinkUp;		//Network link status of EtherCAT
	CEdit WgLblstate;
	CListCtrl WgSlaveList;

	bool timeoutfunc(clock_t startTime);
	void InitConsole();
	int InitDevice();
	int Opendevice();
	int InitModules();
	int Startoptask();
	void ModuleProcess();

	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnClose();
	CEdit WgEL5001_IN;
};
