
// ECAT-M801-DEMO-MOTION-SINGLE-AXISDlg.h : Y
//

#pragma once
#include <stdint.h>
#include "EcatDeviceAPI.h"
#include "EcatErrno.h"
#include "afxwin.h"
#include "afxcmn.h"
#define timeout 3
#define DEV_TIMER_CYCLE_TIME 30 //ms
typedef struct axis_di{
	union
	{
		struct
		{
			uint8_t	NOT		: 1;		//Negative limit switch
			uint8_t	POT		: 1;		//Positive limit switch
			uint8_t	ORG		: 1;		//home switch
			uint8_t	ALM		: 1;		//alarm
			uint8_t	WAN		: 1;		//warning
			uint8_t	SVN		: 1;		//serve on status
			uint8_t	VIR		: 1;		//virtual axis
			uint32_t	reserved : 25;	//Reserved(bit3~bit31)
		};
		uint32_t DIs;
	};
}axis_di_t;


// CECATM801DEMOMOTIONSINGLEAXISDlg ܤ
class CECATM801DEMOMOTIONSINGLEAXISDlg : public CDialog
{
// غc
public:
	CECATM801DEMOMOTIONSINGLEAXISDlg(CWnd* pParent = NULL);	// зǫغc禡

// ܤ
	enum { IDD = IDD_ECATM801DEMOMOTIONSINGLEAXIS_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV 䴩


// {X@
protected:
	HICON m_hIcon;

	// ͪT禡
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	uint16_t DeviceNo;
	bool isOP;
	uint16_t AxisCnt;
	uint16_t AxisNo;
	uint16_t GrpNo;
	double TargetPos;
	void InitConsole();
	int InitDevice();
	int Opendevice();
	int Startoptask();
	void UpdateDeviceState(uint32_t LinkUp, uint32_t SlavesResp, uint32_t AlStates, uint32_t Wc);
	int Initmotion();
	int SetAxisParam();
	int ModuleProcess();
	CString GetAxisStateStr(uint32_t state);

	CString GetGroupStateStr(uint32_t state);

	CEdit WgLblSlavesResp;
	CEdit WgLblAlStates;
	CEdit WgLblWc;
	CEdit WgLblLinkUp;
	CEdit WgLblstate;
	CListCtrl WgAxesInfo;
	CListCtrl WgSlaveList;

	afx_msg void OnTimer(UINT_PTR nIDEvent);
	afx_msg void OnClose();

	int CheckGroupStateBeforeMove();
	void OnBnClickedAxisservoon();
	afx_msg void OnBnClickedAxisservooff();
	afx_msg void OnBnClickedAxismoveabs();
	CEdit WgAxisVel;
	CEdit WgAxisPos;
	afx_msg void OnBnClickedAxismoverel();
	afx_msg void OnBnClickedAxisstop();
	afx_msg void OnBnClickedAxisquickstop();
	afx_msg void OnBnClickedAxismovejogp();
	afx_msg void OnBnClickedAxismovejogm();
	afx_msg void OnBnClickedAxiserrorreset();
};
